SilHUD2 = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0");

local dewdrop = AceLibrary("Dewdrop-2.0")
-- local L = AceLibrary("AceLocale-2.2"):new("SilHUD2")
--local waterfall = AceLibrary("Waterfall-1.0");
SilHUD2:RegisterDB("SilHUD2DB", "SilHUD2DBPC");					
------------------------------------------
--	Frame Initialization	--
------------------------------------------

SilHUD2MasterFrame =  CreateFrame("Frame", "SH2MasterFrame", UIParent);
SilHUD2MasterFrame:SetClampedToScreen(true);
SilHUD2MasterFrameDragText = SilHUD2MasterFrame:CreateFontString(nil, "LOW");
SilHUD2Settings = {};

SH2MASTERTITLEREGION = SilHUD2MasterFrame:CreateTitleRegion();

SH2PLPOWERFRAME = CreateFrame("Frame","PlayerManaFrame",SilHUD2MasterFrame);
SH2PLHEALTHFRAME = CreateFrame("Frame","PlayerHealthFrame",SilHUD2MasterFrame);
SH2PLPOWERTEXT = SH2PLPOWERFRAME:CreateFontString(nil, "LOW");
SH2PLHEALTHTEXT =  SH2PLHEALTHFRAME:CreateFontString(nil, "LOW");
SH2PLHEALTHSCALEFRAME = CreateFrame("Frame", "PlayerHealthScale", SilHUD2MasterFrame);
SH2PLPOWERSCALEFRAME = CreateFrame("Frame", "PlayerManaScale", SilHUD2MasterFrame);
SH2PLHEALTHTITLETEXT = SH2PLHEALTHFRAME:CreateFontString(nil, "LOW");
SH2PLPOWERTITLETEXT = SH2PLPOWERFRAME:CreateFontString(nil, "LOW");

SH2PETFRAME = CreateFrame("Frame", "PetScale", SilHUD2MasterFrame);
SH2PETSCALEFRAME = CreateFrame("Frame", "PetScale", SH2PETFRAME);
SH2PETHEALTHFRAME = CreateFrame("Frame", "PetFrame", SH2PETSCALEFRAME);
SH2PETPOWERFRAME = CreateFrame("Frame", "PetPowerFrame", SH2PETSCALEFRAME);
SH2PETNAMETEXT = SH2PETSCALEFRAME:CreateFontString(nil, "LOW");
SH2PETHEALTHTEXT = SH2PETSCALEFRAME:CreateFontString(nil, "LOW");
SH2PETPOWERTEXT = SH2PETSCALEFRAME:CreateFontString(nil, "LOW");
SH2PETHEALTHTITLE = SH2PETHEALTHFRAME:CreateFontString(nil, "LOW");
SH2PETPOWERTITLE = SH2PETPOWERFRAME:CreateFontString(nil, "LOW");

SH2TARFRAME = CreateFrame("Frame", "PetScale", SilHUD2MasterFrame);
SH2TARSCALEFRAME = CreateFrame("Frame", "TarScale", SH2TARFRAME);
SH2TARHEALTHFRAME = CreateFrame("Frame", "TarFrame", SH2TARSCALEFRAME);
SH2TARPOWERFRAME = CreateFrame("Frame", "TarPowerScale", SH2TARSCALEFRAME);
SH2TARNAMETEXT = SH2TARSCALEFRAME:CreateFontString(nil, "LOW");
SH2TARHEALTHTEXT = SH2TARSCALEFRAME:CreateFontString(nil, "LOW");
SH2TARPOWERTEXT = SH2TARSCALEFRAME:CreateFontString(nil, "LOW");
SH2TARHEALTHTITLE = SH2TARHEALTHFRAME:CreateFontString(nil, "LOW");
SH2TARPOWERTITLE = SH2TARPOWERFRAME:CreateFontString(nil, "LOW");

SH2TARTARFRAME = CreateFrame("Frame", "TarTarFrame", SH2TARFRAME);
SH2TARTARTEXT = SH2TARTARFRAME:CreateFontString(nil, "LOW");
SH2TARTARNAMETEXT = SH2TARTARFRAME:CreateFontString(nil, "LOW");

SH2PLCOMBOFRAME = CreateFrame("Frame", "PlayerComboFrame", SilHUD2MasterFrame);
SH2PLCOMBOTEXT = SH2PLCOMBOFRAME:CreateFontString(nil, "LOW");
SH2PLCOMBOTITLE = SH2PLCOMBOFRAME:CreateFontString(nil, "LOW");
SH2PLENERGYSPARK = CreateFrame("Frame", "PlayerEnergySpark", SH2PLPOWERSCALEFRAME);

SH2INDICATORFRAME = CreateFrame("Frame", "IndicatorFrame", SilHUD2MasterFrame);
SH2AFKFRAME = CreateFrame("Frame", "AFKFrame", SH2INDICATORFRAME);
SH2DNDFRAME = CreateFrame("Frame", "DNDFrame", SH2INDICATORFRAME);
SH2PVPFRAME = CreateFrame("Frame", "PVPFrame", SH2INDICATORFRAME);
SH2PVPCANCELFRAME = CreateFrame("Frame", "PVPCancelFrame", SH2PVPFRAME);
SH2AFKTEXT = SH2AFKFRAME:CreateFontString(nil, "LOW");
SH2DNDTEXT = SH2DNDFRAME:CreateFontString(nil, "LOW");
SH2PVPTEXT = SH2PVPFRAME:CreateFontString(nil, "LOW");

SH2ISLOCKED = true;
SH2TARTARNAME = "";

POWERS = 		{	
					"MANA",
					"RAGE",
					"FOCUS",
					"ENERGY",
					"HAPPINESS"
				};
			
TICKDATA = 	{
					curTime = 0,
					lastTime = 0,
					duration = 2,
					oldEnergy = 0,
					newEnergy = 0,
					sparkPosition = 0
				};

function SilHUD2:MinimapButtonOnEnter()
	GameTooltip:SetOwner(SilHUD2MinimapButtonFrame, "ANCHOR_TOPRIGHT");
	GameTooltip:ClearLines();
	GameTooltip:SetAlpha(1);
	GameTooltip:SetText("SilHUD2             |cffff3333" .. GetAddOnMetadata("SilHUD2", "Version") .. "|r", 1, .9, 0,  1, 1);
	GameTooltip:AddLine("|cff44ff44Right-click|r for dropdown menu", 1,1,1,1,1);
	GameTooltip:AddLine("|cff44ff44Drag|r to reposition button.", 1,1,1,1,1);
	GameTooltip:Show();
end

function SilHUD2:MinimapButtonOnLeave(...)
--	GameTooltip:SetClampedToScreen(false);
	GameTooltip:Hide();
end

------------------------------------------
--	Begin Frame Setup	--
------------------------------------------
		
function SilHUD2:OnEnable()
    -- Called when the addon is enabled
	
    self:RegisterEvent("UNIT_MANA");
	self:RegisterEvent("UNIT_ENERGY");
	self:RegisterEvent("UNIT_RAGE");
	self:RegisterEvent("UNIT_FOCUS");
	self:RegisterEvent("UNIT_MAXENERGY");
	self:RegisterEvent("UNIT_MAXRAGE");
	self:RegisterEvent("UNIT_MAXFOCUS");
	self:RegisterEvent("UNIT_HEALTH");
	self:RegisterEvent("UNIT_MAXHEALTH");
	self:RegisterEvent("UNIT_MAXMANA");
	self:RegisterEvent("UNIT_PET");
	self:RegisterEvent("UNIT_TARGET");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_COMBO_POINTS");
	self:RegisterEvent("PLAYER_AURAS_CHANGED");
	
	SilHUD2:PopulateOptions();
	
--	waterfall:Register('SilHUD2Menu', 'aceOptions', self.sh2options, 'title',"SilHUD2 v" .. GetAddOnMetadata("SilHUD2", "Version"));
	dewdrop:Register(SilHUD2MinimapButtonFrame, 'children', function() dewdrop:FeedAceOptionsTable(self.sh2options) end);
	
	SilHUD2:Init(false);
end

function SilHUD2:Init(reset)
	local powerType = UnitPowerType("player");
	
	SilHUD2:SetDefaults();
	
	if reset == false then
		SilHUD2:InitializeSettings();
	end
	
	SilHUD2:RegisterChatCommand("/shdebug", self.sh2debug);
	
	SilHUD2MasterFrame:SetFrameStrata("LOW");
	SilHUD2MasterFrame:ClearAllPoints();
	SilHUD2MasterFrame:SetPoint(SilHUD2Settings.master.myPoint, getglobal(SilHUD2Settings.master.parent), SilHUD2Settings.master.parPoint, SilHUD2Settings.master.offX, SilHUD2Settings.master.offY);
	SilHUD2MasterFrame:SetWidth(SilHUD2Settings.master.width);
	SilHUD2MasterFrame:SetHeight(SilHUD2Settings.master.height);
	
	SilHUD2MasterFrameDragText:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 20);
	SilHUD2MasterFrameDragText:SetTextColor(0,0,0,1);
	SilHUD2MasterFrameDragText:SetJustifyH("CENTER");
	SilHUD2MasterFrameDragText:ClearAllPoints();
	SilHUD2MasterFrameDragText:SetPoint("CENTER", SilHUD2MasterFrame, "CENTER",0,0);
	SilHUD2MasterFrameDragText:SetText("DRAG TO\nREPOSITION");
	SilHUD2MasterFrameDragText:Hide()
	
	SH2PLPOWERFRAME:SetFrameStrata("LOW");
	SH2PLPOWERFRAME:ClearAllPoints();
	SH2PLPOWERFRAME:SetPoint("BOTTOMRIGHT", SilHUD2MasterFrame, "BOTTOMRIGHT");
	SH2PLPOWERFRAME:SetWidth(10);
	SH2PLPOWERFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\whitebackdropbase", edgeFile =  nil, tile = true, tilesize = 200, edgesize = 0});
		
	SH2PLPOWERTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 10);
	SH2PLPOWERTEXT:SetJustifyH("RIGHT");
	SH2PLPOWERTEXT:ClearAllPoints();
	SH2PLPOWERTEXT:SetPoint("RIGHT", SH2PLPOWERFRAME, "TOPLEFT",0,-1);
	
	SH2PLHEALTHSCALEFRAME:SetFrameStrata("LOW");
	SH2PLHEALTHSCALEFRAME:ClearAllPoints();
	SH2PLHEALTHSCALEFRAME:SetPoint("BOTTOMRIGHT", SH2PLHEALTHFRAME, "BOTTOMLEFT", -1,0);
	SH2PLHEALTHSCALEFRAME:SetWidth(12);
	SH2PLHEALTHSCALEFRAME:SetHeight(SilHUD2MasterFrame:GetHeight());
	SH2PLHEALTHSCALEFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\scalebackdropleft", edgefile = nil, tile = false});
		
	
	SH2PLPOWERSCALEFRAME:SetFrameStrata("LOW");
	SH2PLPOWERSCALEFRAME:ClearAllPoints();
	SH2PLPOWERSCALEFRAME:SetPoint("BOTTOMLEFT", SH2PLPOWERFRAME, "BOTTOMRIGHT", 1,0);
	SH2PLPOWERSCALEFRAME:SetWidth(12);
	SH2PLPOWERSCALEFRAME:SetHeight(SilHUD2MasterFrame:GetHeight());
	SH2PLPOWERSCALEFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\scalebackdropright", edgefile = nil, tile = false});
		
	SH2PLHEALTHFRAME:SetFrameStrata("LOW");
	SH2PLHEALTHFRAME:ClearAllPoints();
	SH2PLHEALTHFRAME:SetPoint("BOTTOMLEFT", SilHUD2MasterFrame, "BOTTOMLEFT");
	SH2PLHEALTHFRAME:SetWidth(10);
	SH2PLHEALTHFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\whitebackdropbase", edgeFile =  nil, tile = true, tilesize = 200, edgesize = 0});
		
	SH2PLHEALTHTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 10);
	SH2PLHEALTHTEXT:SetJustifyH("LEFT");
	SH2PLHEALTHTEXT:ClearAllPoints();
	SH2PLHEALTHTEXT:SetPoint("LEFT", SH2PLHEALTHFRAME, "TOPRIGHT",-1,-1);
	
	SH2PLHEALTHTITLETEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 10);
	SH2PLHEALTHTITLETEXT:SetJustifyH("LEFT");
	SH2PLHEALTHTITLETEXT:ClearAllPoints();
	SH2PLHEALTHTITLETEXT:SetPoint("TOPLEFT", SH2PLHEALTHSCALEFRAME, "BOTTOMLEFT", 0, -5);
	SH2PLHEALTHTITLETEXT:SetText("HEALTH");
	
	SH2PLPOWERTITLETEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 10);
	SH2PLPOWERTITLETEXT:SetJustifyH("RIGHT");
	SH2PLPOWERTITLETEXT:ClearAllPoints();
	SH2PLPOWERTITLETEXT:SetPoint("TOPRIGHT", SH2PLPOWERSCALEFRAME, "BOTTOMRIGHT", 0, -5);
	SH2PLPOWERTITLETEXT:SetText(POWERS[UnitPowerType("player") + 1]);

	SH2PETFRAME:SetFrameStrata("LOW");
	SH2PETFRAME:ClearAllPoints();
	SH2PETFRAME:SetPoint(SilHUD2Settings.petFrame.myPoint, getglobal(SilHUD2Settings.petFrame.parent), SilHUD2Settings.petFrame.parPoint, SilHUD2Settings.petFrame.offX, SilHUD2Settings.petFrame.offY);
	SH2PETFRAME:SetWidth(SilHUD2Settings.petFrame.width);
	SH2PETFRAME:SetHeight(SilHUD2Settings.petFrame.height);
		
	SH2PETSCALEFRAME:SetFrameStrata("LOW");
	SH2PETSCALEFRAME:ClearAllPoints();
	SH2PETSCALEFRAME:SetPoint("BOTTOM", SH2PETFRAME, "BOTTOM");
	SH2PETSCALEFRAME:SetWidth(6);
	SH2PETSCALEFRAME:SetHeight(SH2PETFRAME:GetHeight());
	SH2PETSCALEFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\scalebackdropleftmini", edgeFile =  nil, tile = false});
		
	SH2PETHEALTHFRAME:SetFrameStrata("LOW");
	SH2PETHEALTHFRAME:ClearAllPoints();
	SH2PETHEALTHFRAME:SetPoint("BOTTOMLEFT", SH2PETSCALEFRAME, "BOTTOMRIGHT", 3, 0);
	SH2PETHEALTHFRAME:SetWidth(5);
	SH2PETHEALTHFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\whitebackdropbase", edgeFile =  nil, tile = true, tilesize = 200, edgesize = 0});
		
	SH2PETPOWERFRAME:SetFrameStrata("LOW");
	SH2PETPOWERFRAME:ClearAllPoints();
	SH2PETPOWERFRAME:SetPoint("BOTTOMLEFT", SH2PETHEALTHFRAME, "BOTTOMRIGHT", 4, 0);
	SH2PETPOWERFRAME:SetWidth(5);
	SH2PETPOWERFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\whitebackdropbase", edgeFile =  nil, tile = true, tilesize = 200, edgesize = 0});
	SH2PETPOWERFRAME:SetHeight(UnitMana("pet")/UnitManaMax("pet") * SH2PETSCALEFRAME:GetHeight());
	
	SH2PETHEALTHTITLE:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 6);
	SH2PETHEALTHTITLE:SetJustifyH("CENTER");
	SH2PETHEALTHTITLE:ClearAllPoints();
	SH2PETHEALTHTITLE:SetPoint("BOTTOM", SH2PETHEALTHFRAME, "TOP", 0, 1);
	SH2PETHEALTHTITLE:SetText("H");
	
	SH2PETPOWERTITLE:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 6);
	SH2PETPOWERTITLE:SetJustifyH("CENTER");
	SH2PETPOWERTITLE:ClearAllPoints();
	SH2PETPOWERTITLE:SetPoint("BOTTOM", SH2PETPOWERFRAME, "TOP", 1, 1);
	SH2PETPOWERTITLE:SetText(string.sub(POWERS[UnitPowerType("pet") + 1],1,1));
	
	SH2PETNAMETEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 8);
	SH2PETNAMETEXT:SetJustifyH("RIGHT");
	SH2PETNAMETEXT:ClearAllPoints();
	SH2PETNAMETEXT:SetPoint("TOP", SH2PETSCALEFRAME, "BOTTOM", 0, -1);
	SH2PETNAMETEXT:SetText(UnitName("pet"));
	
	SH2PETHEALTHTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 8);
	SH2PETHEALTHTEXT:SetJustifyH("RIGHT");
	SH2PETHEALTHTEXT:ClearAllPoints();
	SH2PETHEALTHTEXT:SetPoint("TOPRIGHT", SH2PETSCALEFRAME, "LEFT", -2, 0);
	SH2PETHEALTHTEXT:SetWidth(120);
	SH2PETHEALTHTEXT:SetText("");

	SH2PETPOWERTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 7);
	SH2PETPOWERTEXT:SetJustifyH("LEFT");
	SH2PETPOWERTEXT:ClearAllPoints();
	SH2PETPOWERTEXT:SetPoint("TOPLEFT", SH2PETSCALEFRAME, "RIGHT", 20, 0);
	SH2PETPOWERTEXT:SetWidth(65);
	SH2PETPOWERTEXT:SetText("100%");
	
	SH2TARFRAME:SetFrameStrata("LOW");
	SH2TARFRAME:ClearAllPoints();
	SH2TARFRAME:SetPoint(SilHUD2Settings.tarFrame.myPoint, getglobal(SilHUD2Settings.tarFrame.parent), SilHUD2Settings.tarFrame.parPoint, SilHUD2Settings.tarFrame.offX, SilHUD2Settings.tarFrame.offY);
	SH2TARFRAME:SetWidth(SilHUD2Settings.tarFrame.width);
	SH2TARFRAME:SetHeight(SilHUD2Settings.tarFrame.height);
	
	SH2TARSCALEFRAME:SetFrameStrata("LOW");
	SH2TARSCALEFRAME:ClearAllPoints();
	SH2TARSCALEFRAME:SetPoint("BOTTOM", SH2TARFRAME, "BOTTOM");
	SH2TARSCALEFRAME:SetWidth(6);
	SH2TARSCALEFRAME:SetHeight(SH2TARFRAME:GetHeight());
	SH2TARSCALEFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\scalebackdroprightmini", edgeFile =  nil, tile = false});
		
	SH2TARHEALTHFRAME:SetFrameStrata("LOW");
	SH2TARHEALTHFRAME:ClearAllPoints();
	SH2TARHEALTHFRAME:SetPoint("BOTTOMRIGHT", SH2TARSCALEFRAME, "BOTTOMLEFT", -3, 0);
	SH2TARHEALTHFRAME:SetWidth(5);
	SH2TARHEALTHFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\whitebackdropbase", edgeFile =  nil, tile = true, tilesize = 200, edgesize = 0});
	
	SH2TARPOWERFRAME:SetFrameStrata("LOW");
	SH2TARPOWERFRAME:ClearAllPoints();
	SH2TARPOWERFRAME:SetPoint("BOTTOMRIGHT", SH2TARHEALTHFRAME, "BOTTOMLEFT", -4, 0);
	SH2TARPOWERFRAME:SetWidth(5);
	SH2TARPOWERFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\whitebackdropbase", edgeFile =  nil, tile = true, tilesize = 200, edgesize = 0});
	SH2TARPOWERFRAME:SetHeight(UnitMana("target")/UnitManaMax("target") * SH2TARSCALEFRAME:GetHeight());
	
	SH2TARHEALTHTITLE:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 6);
	SH2TARHEALTHTITLE:SetJustifyH("CENTER");
	SH2TARHEALTHTITLE:ClearAllPoints();
	SH2TARHEALTHTITLE:SetPoint("BOTTOM", SH2TARHEALTHFRAME, "TOP", 0, 1);
	SH2TARHEALTHTITLE:SetText("H");
	
	SH2TARPOWERTITLE:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 6);
	SH2TARPOWERTITLE:SetJustifyH("CENTER");
	SH2TARPOWERTITLE:ClearAllPoints();
	SH2TARPOWERTITLE:SetPoint("BOTTOM", SH2TARPOWERFRAME, "TOP", -1, 1);
	SH2TARPOWERTITLE:SetText(string.sub(POWERS[UnitPowerType("target") + 1],1,1));
	
	SH2TARNAMETEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 8);
	SH2TARNAMETEXT:SetJustifyH("LEFT");
	SH2TARNAMETEXT:ClearAllPoints();
	SH2TARNAMETEXT:SetPoint("TOPLEFT", SH2TARSCALEFRAME, "BOTTOMLEFT", -15, -1);
	SH2TARNAMETEXT:SetWidth(120);
	
	SH2TARTARFRAME:SetFrameStrata("LOW");
	SH2TARTARFRAME:ClearAllPoints();
	SH2TARTARFRAME:SetPoint("TOPLEFT", SH2TARSCALEFRAME, "TOPRIGHT");
	SH2TARTARFRAME:SetWidth(130);
	SH2TARTARFRAME:SetHeight(30);
	SH2TARTARFRAME:SetScript("OnUpdate", function() SilHUD2:TargetTargetCheck() end);
	
	SH2TARTARTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 6);
	SH2TARTARTEXT:SetJustifyH("LEFT");
	SH2TARTARTEXT:ClearAllPoints();
	SH2TARTARTEXT:SetPoint("TOPLEFT", SH2TARTARFRAME, "TOPLEFT", 5, 0);
	SH2TARTARTEXT:SetWidth(120);
	SH2TARTARTEXT:SetText("TARGETING:")
	
	SH2TARTARNAMETEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 12);
	SH2TARTARNAMETEXT:SetJustifyH("LEFT");
	SH2TARTARNAMETEXT:ClearAllPoints();
	SH2TARTARNAMETEXT:SetPoint("TOPLEFT", SH2TARTARTEXT, "BOTTOMLEFT", 0, -2);
	SH2TARTARNAMETEXT:SetWidth(120);
	
	SH2TARHEALTHTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 8);
	SH2TARHEALTHTEXT:SetJustifyH("LEFT");
	SH2TARHEALTHTEXT:ClearAllPoints();
	SH2TARHEALTHTEXT:SetPoint("TOPLEFT", SH2TARSCALEFRAME, "RIGHT", 2, 0);
	SH2TARHEALTHTEXT:SetWidth(120);
	SH2TARHEALTHTEXT:SetText("0/ 0");
	
	SH2TARPOWERTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 7);
	SH2TARPOWERTEXT:SetJustifyH("RIGHT");
	SH2TARPOWERTEXT:ClearAllPoints();
	SH2TARPOWERTEXT:SetPoint("TOPRIGHT", SH2TARSCALEFRAME, "LEFT", -20, 0);
	SH2TARPOWERTEXT:SetWidth(65);
	SH2TARPOWERTEXT:SetText("100%");
	
	SH2PLCOMBOFRAME:SetFrameStrata("LOW");
	SH2PLCOMBOFRAME:ClearAllPoints();
	SH2PLCOMBOFRAME:SetPoint("TOPLEFT", SH2PLPOWERSCALEFRAME, "TOPRIGHT", 5, 0);
	SH2PLCOMBOFRAME:SetWidth(64);
	SH2PLCOMBOFRAME:SetHeight(54);
	SH2PLCOMBOFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\boxborder", edgeFile = nil, tile = false});
		
	SH2PLCOMBOTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 54);
	SH2PLCOMBOTEXT:SetJustifyH("CENTER");
	SH2PLCOMBOTEXT:ClearAllPoints();
	SH2PLCOMBOTEXT:SetPoint("CENTER", SH2PLCOMBOFRAME, "CENTER", 0, -3);
	SH2PLCOMBOTEXT:SetText("2");
	
	SH2PLCOMBOTITLE:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 9);
	SH2PLCOMBOTITLE:SetJustifyH("CENTER");
	SH2PLCOMBOTITLE:ClearAllPoints();
	SH2PLCOMBOTITLE:SetPoint("TOP", SH2PLCOMBOFRAME, "BOTTOM", 0, -2);
	SH2PLCOMBOTITLE:SetText("COMBO");
	
	SH2PLENERGYSPARK:SetFrameStrata("LOW");
	SH2PLENERGYSPARK:ClearAllPoints();
	SH2PLENERGYSPARK:SetPoint("BOTTOM", SH2PLPOWERSCALEFRAME, "BOTTOM");
	SH2PLENERGYSPARK:SetWidth(12);
	SH2PLENERGYSPARK:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\whitebackdropbase", edgeFile =  nil, tile = true, tilesize = 200, edgesize = 0});
	SH2PLENERGYSPARK:SetHeight(8);
	SH2PLENERGYSPARK:SetAlpha(0.8);
	SH2PLENERGYSPARK:Hide();
	
	SH2INDICATORFRAME:SetFrameStrata("LOW");
	SH2INDICATORFRAME:ClearAllPoints();
	SH2INDICATORFRAME:SetPoint("TOPRIGHT", SH2PLHEALTHSCALEFRAME, "TOPLEFT", -5, 0);
	SH2INDICATORFRAME:SetWidth(68);
	SH2INDICATORFRAME:SetHeight(75);
	SH2INDICATORFRAME:SetScript("OnUpdate", function() SilHUD2:Indicators() end);
	
	SH2PVPFRAME:SetFrameStrata("LOW");
	SH2PVPFRAME:ClearAllPoints();
	SH2PVPFRAME:SetPoint("TOP", SH2INDICATORFRAME, "TOP", 0, 0);
	SH2PVPFRAME:SetWidth(64);
	SH2PVPFRAME:SetHeight(28);
	SH2PVPFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\boxborder", edgeFile = nil, tile = false});
	
	SH2PVPCANCELFRAME:SetFrameStrata("LOW");
	SH2PVPCANCELFRAME:ClearAllPoints();
	SH2PVPCANCELFRAME:SetPoint("TOP", SH2INDICATORFRAME, "TOP", 0, 0);
	SH2PVPCANCELFRAME:SetWidth(64);
	SH2PVPCANCELFRAME:SetHeight(28);
	SH2PVPCANCELFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\pvpcancel", edgeFile = nil, tile = false});
	
	
	SH2PVPTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 16);
	SH2PVPTEXT:SetJustifyH("CENTER");
	SH2PVPTEXT:ClearAllPoints();
	SH2PVPTEXT:SetPoint("CENTER", SH2PVPFRAME, "CENTER", 0, -2);
	SH2PVPTEXT:SetText("PVP");
	
	SH2AFKFRAME:SetFrameStrata("LOW");
	SH2AFKFRAME:ClearAllPoints();
	SH2AFKFRAME:SetPoint("TOP", SH2PVPFRAME, "BOTTOM", 0, -5);
	SH2AFKFRAME:SetWidth(64);
	SH2AFKFRAME:SetHeight(28);
	SH2AFKFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\boxborder", edgeFile = nil, tile = false});
	
	SH2AFKTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 16);
	SH2AFKTEXT:SetJustifyH("CENTER");
	SH2AFKTEXT:ClearAllPoints();
	SH2AFKTEXT:SetPoint("CENTER", SH2AFKFRAME, "CENTER", 0, -2);
	SH2AFKTEXT:SetText("AFK");
	
	SH2DNDFRAME:SetFrameStrata("LOW");
	SH2DNDFRAME:ClearAllPoints();
	SH2DNDFRAME:SetPoint("TOP", SH2AFKFRAME, "BOTTOM", 0, -5);
	SH2DNDFRAME:SetWidth(64);
	SH2DNDFRAME:SetHeight(28);
	SH2DNDFRAME:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\boxborder", edgeFile = nil, tile = false});
	
	SH2DNDTEXT:SetFont("Interface\\AddOns\\SilHUD2\\Fonts\\digitale.ttf", 16);
	SH2DNDTEXT:SetJustifyH("CENTER");
	SH2DNDTEXT:ClearAllPoints();
	SH2DNDTEXT:SetPoint("CENTER", SH2DNDFRAME, "CENTER", 0, -2);
	SH2DNDTEXT:SetText("DND");
	
	SH2AFKFRAME:Hide();
	SH2DNDFRAME:Hide();
	SH2PVPFRAME:Hide();
	SH2PVPCANCELFRAME:Hide();
	
	if UnitPowerType("player") == 3 then
		SilHUD2:SparkInit()
	end
	
	SilHUD2:PowerUpdate("player");
	SilHUD2:UNIT_TARGET("player");
	SilHUD2:PLAYER_COMBO_POINTS();
	SilHUD2:UNIT_PET("player");
	SilHUD2:UNIT_HEALTH("player");
	SilHUD2:Transparency();
	SilHUD2:ColorStuff(true);
end
------------------------------------------
--	End Frame Setup		--
--	Begin functions		--
------------------------------------------
function SilHUD2:ColorStuff(colorAllFrames)
	if colorAllFrames then
		SH2PLHEALTHSCALEFRAME:SetBackdropColor(SilHUD2Settings.colors.plHealthScale.R, SilHUD2Settings.colors.plHealthScale.G, SilHUD2Settings.colors.plHealthScale.B,1);
		SH2PLHEALTHFRAME:SetBackdropColor(SilHUD2Settings.colors.plHealth.R, SilHUD2Settings.colors.plHealth.G, SilHUD2Settings.colors.plHealth.B, 1);
		
		SH2PLPOWERSCALEFRAME:SetBackdropColor(SilHUD2Settings.colors.plPowerScale.R, SilHUD2Settings.colors.plPowerScale.G, SilHUD2Settings.colors.plPowerScale.B,1);
		SH2PLPOWERFRAME:SetBackdropColor(SilHUD2Settings.colors.plPower.R, SilHUD2Settings.colors.plPower.G, SilHUD2Settings.colors.plPower.B,1);
		
		SH2TARHEALTHFRAME:SetBackdropColor(SilHUD2Settings.colors.tarHealth.R,SilHUD2Settings.colors.tarHealth.G,SilHUD2Settings.colors.tarHealth.B,1);
		SH2TARSCALEFRAME:SetBackdropColor(SilHUD2Settings.colors.tarHealthScale.R,SilHUD2Settings.colors.tarHealthScale.G,SilHUD2Settings.colors.tarHealthScale.B,1);
		
		SH2PETPOWERFRAME:SetBackdropColor(SilHUD2Settings.colors.petPower.R, SilHUD2Settings.colors.petPower.G, SilHUD2Settings.colors.petPower.B,1);
		SH2PETHEALTHFRAME:SetBackdropColor(SilHUD2Settings.colors.petHealth.R, SilHUD2Settings.colors.petHealth.G, SilHUD2Settings.colors.petHealth.B,1);
		SH2PETSCALEFRAME:SetBackdropColor(SilHUD2Settings.colors.petHealthScale.R, SilHUD2Settings.colors.petHealthScale.G, SilHUD2Settings.colors.petHealthScale.B,1);
		
		SH2PLPOWERTITLETEXT:SetTextColor(SilHUD2Settings.colors.plPowerScale.R, SilHUD2Settings.colors.plPowerScale.G, SilHUD2Settings.colors.plPowerScale.B,1);
		SH2PLHEALTHTITLETEXT:SetTextColor(SilHUD2Settings.colors.plHealthScale.R, SilHUD2Settings.colors.plHealthScale.G, SilHUD2Settings.colors.plHealthScale.B,1);
		SH2PLHEALTHTEXT:SetTextColor(SilHUD2Settings.colors.plHealth.R, SilHUD2Settings.colors.plHealth.G, SilHUD2Settings.colors.plHealth.B, 1);
		SH2PLPOWERTEXT:SetTextColor(SilHUD2Settings.colors.plPower.R, SilHUD2Settings.colors.plPower.G, SilHUD2Settings.colors.plPower.B,1);
		
		SH2PETPOWERTEXT:SetTextColor(SilHUD2Settings.colors.petPower.R, SilHUD2Settings.colors.petPower.G, SilHUD2Settings.colors.petPower.B,1);
		SH2PETHEALTHTEXT:SetTextColor(SilHUD2Settings.colors.petHealth.R, SilHUD2Settings.colors.petHealth.G, SilHUD2Settings.colors.petHealth.B,1);
		SH2PETNAMETEXT:SetTextColor(SilHUD2Settings.colors.petHealthScale.R, SilHUD2Settings.colors.petHealthScale.G, SilHUD2Settings.colors.petHealthScale.B,1);
		SH2PETPOWERTITLE:SetTextColor(SilHUD2Settings.colors.petPower.R, SilHUD2Settings.colors.petPower.G, SilHUD2Settings.colors.petPower.B,1);
		SH2PETHEALTHTITLE:SetTextColor(SilHUD2Settings.colors.petHealth.R, SilHUD2Settings.colors.petHealth.G, SilHUD2Settings.colors.petHealth.B,1);
		
		SH2TARHEALTHTEXT:SetTextColor(SilHUD2Settings.colors.tarHealth.R,SilHUD2Settings.colors.tarHealth.G,SilHUD2Settings.colors.tarHealth.B,1);
		SH2TARNAMETEXT:SetTextColor(SilHUD2Settings.colors.tarHealthScale.R,SilHUD2Settings.colors.tarHealthScale.G,SilHUD2Settings.colors.tarHealthScale.B,1);
		SH2TARHEALTHTITLE:SetTextColor(SilHUD2Settings.colors.tarHealth.R,SilHUD2Settings.colors.tarHealth.G,SilHUD2Settings.colors.tarHealth.B,1);
		SH2TARTARTEXT:SetTextColor(SilHUD2Settings.colors.tarHealthScale.R,SilHUD2Settings.colors.tarHealthScale.G,SilHUD2Settings.colors.tarHealthScale.B,1);
		SH2TARTARNAMETEXT:SetTextColor(SilHUD2Settings.colors.tarHealthScale.R,SilHUD2Settings.colors.tarHealthScale.G,SilHUD2Settings.colors.tarHealthScale.B,1);
		
		SH2PLCOMBOFRAME:SetBackdropColor(SilHUD2Settings.colors.comboFrame.R, SilHUD2Settings.colors.comboFrame.G, SilHUD2Settings.colors.comboFrame.B, 1, 1);
		SH2PLCOMBOTITLE:SetTextColor(SilHUD2Settings.colors.comboFrame.R, SilHUD2Settings.colors.comboFrame.G, SilHUD2Settings.colors.comboFrame.B, 1);
		SH2PLCOMBOTEXT:SetTextColor(SilHUD2Settings.colors.comboFrame.R, SilHUD2Settings.colors.comboFrame.G , SilHUD2Settings.colors.comboFrame.B , 1);
		SH2PLENERGYSPARK:SetBackdropColor(SilHUD2Settings.colors.plPowerScale.R, SilHUD2Settings.colors.plPowerScale.G, SilHUD2Settings.colors.plPowerScale.B,0.9);
		
		SH2AFKFRAME:SetBackdropColor(SilHUD2Settings.colors.indicatorPanel.R, SilHUD2Settings.colors.indicatorPanel.G, SilHUD2Settings.colors.indicatorPanel.B, 1);
		SH2PVPFRAME:SetBackdropColor(SilHUD2Settings.colors.indicatorPanel.R, SilHUD2Settings.colors.indicatorPanel.G, SilHUD2Settings.colors.indicatorPanel.B, 1);
		SH2DNDFRAME:SetBackdropColor(SilHUD2Settings.colors.indicatorPanel.R, SilHUD2Settings.colors.indicatorPanel.G, SilHUD2Settings.colors.indicatorPanel.B, 1);
		SH2AFKTEXT:SetTextColor(SilHUD2Settings.colors.indicatorPanel.R, SilHUD2Settings.colors.indicatorPanel.G, SilHUD2Settings.colors.indicatorPanel.B, 1);
		SH2PVPTEXT:SetTextColor(SilHUD2Settings.colors.indicatorPanel.R, SilHUD2Settings.colors.indicatorPanel.G, SilHUD2Settings.colors.indicatorPanel.B, 1);
		SH2DNDTEXT:SetTextColor(SilHUD2Settings.colors.indicatorPanel.R, SilHUD2Settings.colors.indicatorPanel.G, SilHUD2Settings.colors.indicatorPanel.B, 1);
		
		if	SilHUD2Settings.toggles.matchBlizz then
			local targetPowerType = UnitPowerType("target");
			if targetPowerType == 0 then
				SH2TARPOWERFRAME:SetBackdropColor(0.0, 0.0, 0.9,1);
				SH2TARPOWERTEXT:SetTextColor(0.0, 0.0, 0.9,1);
				SH2TARPOWERTITLE:SetTextColor(0.0, 0.0, 0.9,1);
			elseif targetPowerType == 1 then
				SH2TARPOWERFRAME:SetBackdropColor(0.9, 0.0, 0.0,1);
				SH2TARPOWERTEXT:SetTextColor(0.9, 0.0, 0.0,1);
				SH2TARPOWERTITLE:SetTextColor(0.9, 0.0, 0.0,1);
			elseif targetPowerType == 2 then
				SH2TARPOWERFRAME:SetBackdropColor(1, 0.6, 0.0,1);
				SH2TARPOWERTEXT:SetTextColor(1, 0.6, 0.0,1);
				SH2TARPOWERTITLE:SetTextColor(1, 0.6, 0.0,1);
			elseif targetPowerType == 3 then
				SH2TARPOWERFRAME:SetBackdropColor(0.8, 0.8, 0.0,1);
				SH2TARPOWERTEXT:SetTextColor(0.8, 0.8, 0.0,1);
				SH2TARPOWERTITLE:SetTextColor(0.8, 0.8, 0.0,1);
			end
		else
			SH2TARPOWERFRAME:SetBackdropColor(SilHUD2Settings.colors.tarPower.R,SilHUD2Settings.colors.tarPower.G,SilHUD2Settings.colors.tarPower.B,1);
			SH2TARPOWERTEXT:SetTextColor(SilHUD2Settings.colors.tarPower.R,SilHUD2Settings.colors.tarPower.G,SilHUD2Settings.colors.tarPower.B,1);
			SH2TARPOWERTITLE:SetTextColor(SilHUD2Settings.colors.tarPower.R,SilHUD2Settings.colors.tarPower.G,SilHUD2Settings.colors.tarPower.B,1);
		end
	end
	if SilHUD2Settings.toggles.warnings then
		local percentHealth = UnitHealth("player")/UnitHealthMax("player");
		if percentHealth < 0.2 then
			SH2PLHEALTHFRAME:SetBackdropColor(0.9, 0.0, 0.0, 1);
		elseif percentHealth < 0.4 then
			SH2PLHEALTHFRAME:SetBackdropColor(0.9, 0.5, 0.0, 1);
		elseif percentHealth < 0.55 then
			SH2PLHEALTHFRAME:SetBackdropColor(1, 1, 0, 1);
		else
			SH2PLHEALTHFRAME:SetBackdropColor(SilHUD2Settings.colors.plHealth.R, SilHUD2Settings.colors.plHealth.G, SilHUD2Settings.colors.plHealth.B, 1);
		end
	end
end
	
function SilHUD2:SetDefaults()
	SilHUD2Defaults = 	{
						master =	{
										width = UIParent:GetWidth() * 0.35,
										height = UIParent:GetHeight() * 0.35,
										parent = "UIParent",
										myPoint = "CENTER",
										parPoint = "CENTER",
										offX = 0,
										offY = -30,
									},
						petFrame = 	{
										width = UIParent:GetWidth() / 11,
										height = UIParent:GetHeight() * .35 * .4,
										parent = "SilHUD2MasterFrame",
										myPoint = "BOTTOMRIGHT",
										parPoint = "BOTTOMLEFT",
										offX = 0,
										offY = 10
									},
						tarFrame =	{
										width = UIParent:GetWidth() / 11,
										height = UIParent:GetHeight() * .35 * .4,
										parent = "SilHUD2MasterFrame",
										myPoint = "BOTTOMLEFT",
										parPoint = "BOTTOMRIGHT",
										offX = 0,
										offY = 10
									},
						alphas =	{
										globalAlpha = 1,
										highAlpha = 1,
										midAlpha = 0.6,
										lowAlpha = 0.2
									},
						toggles	=	{
										contextOn = false,
										matchBlizz = false,
										allColors = true,
										warnings = false,
										sh2debug = false
									},
						colors = 	{
										plHealth = {R = 0.2, G = 0.9, B = 0.4},
										plPower = {R = 0.2, G = 0.9, B = 0.4},
										plHealthScale = {R = 0.2, G = 0.9, B = 0.4},
										plPowerScale = {R = 0.2, G = 0.9, B = 0.4},
										petHealth = {R = 0.2, G = 0.9, B = 0.4},
										petPower = {R = 0.2, G = 0.9, B = 0.4},
										petHealthScale = {R = 0.2, G = 0.9, B = 0.4},
										tarHealth = {R = 0.2, G = 0.9, B = 0.4},
										tarPower = {R = 0.2, G = 0.9, B = 0.4},
										tarHealthScale = {R = 0.2, G = 0.9, B = 0.4},
										comboFrame = {R = 0.2, G = 0.9, B = 0.4},
										indicatorPanel = {R = 0.2, G = 0.9, B = 0.4}
									}
					};
end
	
function SilHUD2:InitializeSettings()
	SilHUD2:TableCopy(SilHUD2Defaults, SilHUD2Settings, false);
	SilHUD2:TableCopy(SilHUD2DBPC, SilHUD2Settings, true);
end

function SilHUD2:TableCopy(passTable, targetTable, copy)
	local a, b;
	for a, b in pairs(passTable) do 
		if type(passTable[a]) == "table" then
			if not copy then
				targetTable[a] = {}
			end
			SilHUD2:TableCopy(passTable[a], targetTable[a])
		else
			targetTable[a] = b;
		end
	end
end
		
	
function SilHUD2:UNIT_HEALTH(arg1)
	if arg1 == "player" then
		local currentHealth, maxHealth = UnitHealth(arg1), UnitHealthMax(arg1);
		SH2PLHEALTHFRAME:SetHeight(currentHealth/maxHealth*SilHUD2MasterFrame:GetHeight());
		if (currentHealth/maxHealth*SilHUD2MasterFrame:GetHeight()) < 1 then
			SH2PLHEALTHFRAME:SetHeight(1);
		end
		local PLHealth = " " .. currentHealth .. "/" .. maxHealth;
		SH2PLHEALTHTEXT:SetText(PLHealth);
	elseif arg1 == "pet" then
		local currentHealth, maxHealth = UnitHealth(arg1), UnitHealthMax(arg1);
		local petHealthText = currentHealth .. "/ " .. maxHealth
		if UnitName("pet") and UnitName("pet") ~= "Unknown" then
			SH2PETSCALEFRAME:Show();
			SH2PETNAMETEXT:SetText(UnitName("pet"));
		else
			SH2PETSCALEFRAME:Hide();
		end
		if (UnitHealth("pet") / UnitHealthMax("pet")) <= 0 then
			SH2PETHEALTHFRAME:SetHeight(1);
			SH2PETPOWERFRAME:SetHeight(1);
			SH2PETHEALTHTEXT:SetText("DEAD");
			SH2PETPOWERTEXT:SetText("0%");
		else
			SH2PETHEALTHFRAME:SetHeight(currentHealth / maxHealth * SH2PETSCALEFRAME:GetHeight());
			SH2PETHEALTHTEXT:SetText(petHealthText);
		end
	elseif arg1 == "target" then
		targetHealthText = SilHUD2:UpdateTargetHealthText();
		SH2TARHEALTHFRAME:SetHeight(UnitHealth("target") / UnitHealthMax("target") * SH2TARSCALEFRAME:GetHeight());
		SH2TARHEALTHTEXT:SetText(targetHealthText);
	end
	SilHUD2:Transparency();
	SilHUD2:ColorStuff(false);
end

function SilHUD2:UNIT_MAXHEALTH(arg1)
	if arg1 == "player" then
		local currentHealth, maxHealth = UnitHealth(arg1), UnitHealthMax(arg1);
		SilHUD2:UNIT_HEALTH("player");
	elseif arg1 == "pet" then
		local currentHealth, maxHealth = UnitHealth(arg1), UnitHealthMax(arg1);
		if UnitName("pet") and UnitName("pet") ~= "Unknown" then
			SH2PETSCALEFRAME:Show();
		else
			SH2PETSCALEFRAME:Hide();
		end
		SH2PETHEALTHFRAME:SetHeight(currentHealth/maxHealth * SH2PETSCALEFRAME:GetHeight());
		SH2PETHEALTHTEXT:SetText(currentHealth .. "/ " .. maxHealth);
	elseif arg1 == "target" then
		targetHealthText = SilHUD2:UpdateTargetHealthText();
		SH2TARHEALTHFRAME:SetHeight(UnitHealth("target") / UnitHealthMax("target") * SH2TARSCALEFRAME:GetHeight());
		SH2TARHEALTHTEXT:SetText(targetHealthText);
	end
	SilHUD2:Transparency();
end

function SilHUD2:UNIT_MANA(arg1)
	SilHUD2:PowerUpdate(arg1);
end

function SilHUD2:UNIT_MAXMANA(arg1)
	SilHUD2:PowerUpdate(arg1);
end

function SilHUD2:UNIT_ENERGY(arg1)
	SilHUD2:PowerUpdate(arg1);
	if UnitMana("player") < TICKDATA.oldEnergy then
		TICKDATA.oldEnergy = UnitMana("player")
	end
end

function SilHUD2:UNIT_MAXENERGY(arg1)
	SilHUD2:PowerUpdate(arg1);
end

function SilHUD2:UNIT_RAGE(arg1)
	SilHUD2:PowerUpdate(arg1);
end

function SilHUD2:UNIT_MAXRAGE(arg1)
	SilHUD2:PowerUpdate(arg1);
end

function SilHUD2:UNIT_PET(arg1)
	if arg1 == "player" then
		if UnitName("pet") and UnitName("pet") ~= "Unknown" then
			SH2PETSCALEFRAME:Show();
			SH2PETNAMETEXT:SetText(UnitName("pet"));
			SilHUD2:UNIT_HEALTH("pet");
			SilHUD2:UNIT_MANA("pet");
		else
			SH2PETSCALEFRAME:Hide();
		end
	end
	SilHUD2:Transparency();
end

function SilHUD2:UNIT_TARGET(arg1)
	if arg1 == "player" then
		local targetName, realm= UnitName("target");
		local comboTotal = GetComboPoints();
		SilHUD2:Transparency();
		SilHUD2:ColorStuff(true);
		if targetName and targetName ~= "Unknown" then
			if (UnitHealth("target") / UnitHealthMax("target") * SH2TARSCALEFRAME:GetHeight()) < 1 then
				SH2TARHEALTHFRAME:SetHeight(1);
			else
				SH2TARHEALTHFRAME:SetHeight(UnitHealth("target") / UnitHealthMax("target") * SH2TARSCALEFRAME:GetHeight());
			end
			if UnitManaMax("target") == 0 then
				SH2TARPOWERTEXT:SetText("");
			else
				SH2TARPOWERTEXT:SetText(math.floor(UnitMana("target")/UnitManaMax("target") * 100) .. "%");
			end
			if (UnitMana("target")/UnitManaMax("target") * 100) < 1 then
				SH2TARPOWERFRAME:SetHeight(1);
			else
				SH2TARPOWERFRAME:SetHeight(UnitMana("target")/UnitManaMax("target") * SH2TARSCALEFRAME:GetHeight());
			end
			SH2TARFRAME:Show();
			SH2TARNAMETEXT:SetText(targetName);
			local targetHealthText = SilHUD2:UpdateTargetHealthText()
			SH2TARHEALTHTEXT:SetText(targetHealthText);
			SH2TARPOWERTITLE:SetText(string.sub(POWERS[UnitPowerType("target") + 1],1,1));
		else
			SH2TARFRAME:Hide();
		end
		if comboTotal > 0 then
			SH2PLCOMBOFRAME:Show();
			SH2PLCOMBOTEXT:SetText(comboTotal);
		else
			SH2PLCOMBOFRAME:Hide();
			SH2PLCOMBOTEXT:SetText("0");
		end
	end
end

function SilHUD2:UNIT_FOCUS(arg1)
	if arg1 == "pet" then
		if (UnitMana("pet")/UnitManaMax("pet") * 100) < 1 then
			SH2PETPOWERFRAME:SetHeight(1);
		else
			SH2PETPOWERFRAME:SetHeight(UnitMana("pet")/UnitManaMax("pet") * SH2PETSCALEFRAME:GetHeight());
		end
		SH2PETPOWERTEXT:SetText((UnitMana("pet")/UnitManaMax("pet") * 100) .. "%");
	end
end

function SilHUD2:UNIT_MAXFOCUS(arg1)
	if arg1 == "pet" then
		if (UnitMana("pet")/UnitManaMax("pet") * 100) < 1 then
			SH2PETPOWERFRAME:SetHeight(1);
		else
			SH2PETPOWERFRAME:SetHeight(UnitMana("pet")/UnitManaMax("pet") * SH2PETSCALEFRAME:GetHeight());
		end
		SH2PETPOWERTEXT:SetText((UnitMana("pet")/UnitManaMax("pet") * 100) .. "%");
	end
end

function SilHUD2:PLAYER_REGEN_DISABLED(arg1)
	SilHUD2:Transparency();
end

function SilHUD2:PLAYER_REGEN_ENABLED(arg1)
	SilHUD2:Transparency();
end

function SilHUD2:UpdateTargetHealthText(...)
	local percentageHealth = UnitHealth("target");
	local targetHealthText = percentageHealth .. "%";
	local currentHealth, maxHealth, targetHealthText;
	
	SilHUD2:Transparency();
	if MobHealthFrame then
		currentHealth, maxHealth = MobHealth_GetTargetCurHP(), MobHealth_GetTargetMaxHP();
		if currentHealth and maxHealth then
			targetHealthText = currentHealth .. "/ " .. maxHealth;
		elseif percentageHealth == 0 then
			targetHealthText = "DEAD";
		elseif UnitGUID("target") == UnitGUID("pet") or UnitInParty("target") then
			targetHealthText = UnitHealth("target") .. "/ " .. UnitHealthMax("target");
		else
			targetHealthText = percentageHealth .. "%";
		end
	else
		if UnitGUID("target") == UnitGUID("pet") or UnitInParty("target") then
			targetHealthText = percentageHealth .. "/ " .. UnitHealthMax("target");
		else
			targetHealthText = percentageHealth .. "%";
		end
	end
	if percentageHealth == 0 then
		targetHealthText = "DEAD";
	end
	return targetHealthText;
end

function SilHUD2:PowerUpdate(arg1)
	local currentMana, maxMana = UnitMana(arg1), UnitManaMax(arg1);
	
	SilHUD2:Transparency();
	SilHUD2:ColorStuff(false);
	if 	arg1 == "player" then
		SH2PLPOWERFRAME:SetHeight(currentMana/maxMana*SilHUD2MasterFrame:GetHeight());
		if (currentMana/maxMana*SilHUD2MasterFrame:GetHeight()) < 1 then
			SH2PLPOWERFRAME:SetHeight(1);
		end
		local PLMana = currentMana .. "/" .. maxMana .. " ";
		SH2PLPOWERTEXT:SetText(PLMana); 
	elseif arg1 == "pet" then
		if (UnitMana("pet")/UnitManaMax("pet") * 100) < 1 then
			SH2PETPOWERFRAME:SetHeight(1);
		else
			SH2PETPOWERFRAME:SetHeight(UnitMana("pet")/UnitManaMax("pet") * SH2PETSCALEFRAME:GetHeight());
		end
		SH2PETPOWERTEXT:SetText(math.floor(UnitMana("pet")/UnitManaMax("pet") * 100) .. "%");
		if UnitManaMax("pet") == 0 then
			SH2PETPOWERTEXT:Hide();
		else
			SH2PETPOWERTEXT:Show();
		end
	elseif arg1 == "target" then
		if (UnitMana("target")/UnitManaMax("target") * 100) < 1 then
			SH2TARPOWERFRAME:SetHeight(1);
		else
			SH2TARPOWERFRAME:SetHeight(UnitMana("target")/UnitManaMax("target") * SH2TARSCALEFRAME:GetHeight());
		end
		SH2TARPOWERTEXT:SetText(math.floor(UnitMana("target")/UnitManaMax("target") * 100) .. "%");
		SH2TARPOWERTITLE:SetText(string.sub(POWERS[UnitPowerType("target") + 1],1,1));
	end
end

function SilHUD2:PLAYER_COMBO_POINTS(arg1)
	local comboTotal = GetComboPoints();
	
	if comboTotal > 0 then
		SH2PLCOMBOFRAME:Show();
		SH2PLCOMBOTEXT:SetText(comboTotal);
	else
		SH2PLCOMBOFRAME:Hide();
		SH2PLCOMBOTEXT:SetText("0");
	end
end	

function SilHUD2:PLAYER_AURAS_CHANGED(arg1)
	local localClass, englishClass = UnitClass("player");
	
	if englishClass == "DRUID" then
		SH2PLPOWERTITLETEXT:SetText(POWERS[UnitPowerType("player") + 1]);
		SilHUD2:PowerUpdate("player");
		if UnitPowerType("player") == 3 then
			SilHUD2:SparkInit();
		else
			SH2PLENERGYSPARK:Hide();
		end
	end
	SilHUD2:Transparency();
end
		
function SilHUD2:UpdateFrameHeights()
	local masterHeight = SilHUD2MasterFrame:GetHeight();
	
	SH2PLHEALTHSCALEFRAME:SetHeight(masterHeight);
	SH2PLPOWERSCALEFRAME:SetHeight(masterHeight);
	SilHUD2:UNIT_HEALTH("player");
	SilHUD2:UNIT_MANA("player");
	
	SH2TARSCALEFRAME:SetHeight(masterHeight * .4);
	SilHUD2:UNIT_HEALTH("target");
	SilHUD2:UNIT_MANA("target");
	
	SH2PETSCALEFRAME:SetHeight(masterHeight * .4);
	SilHUD2:UNIT_HEALTH("pet");
	SilHUD2:UNIT_MANA("pet");
end

function SilHUD2:Lock()
	if SH2ISLOCKED == false then
		SilHUD2MasterFrame:SetBackdrop({bgFile = "Interface\\AddOns\\SilHUD2\\Graphics\\whitebackdropbase", tile = true, tilesize = SilHUD2MasterFrame:GetWidth()/10});
		SilHUD2MasterFrame:SetBackdropColor(0.6, 0.6, 0.6, 0.75);
		SilHUD2MasterFrame:EnableMouse(true);
		SilHUD2MasterFrame:SetMovable(true);
		SH2MASTERTITLEREGION:SetAllPoints(SilHUD2MasterFrame);
		SilHUD2MasterFrame:SetAlpha(1);
		SilHUD2MasterFrameDragText:Show();
	elseif SH2ISLOCKED == true then
		SilHUD2MasterFrame:SetBackdropColor(0.2, 0.2, 0.2, 0.0);
		SilHUD2MasterFrame:EnableMouse(false);
		SilHUD2MasterFrame:SetMovable(false);
		SH2MASTERTITLEREGION:ClearAllPoints();
		SilHUD2MasterFrameDragText:Hide();
		SilHUD2:Transparency();
	end
end

function SilHUD2:Transparency()
	local localClass, englishClass = UnitClass("player");
	if SH2ISLOCKED == false then
		return
	end
	if SilHUD2Settings.toggles.contextOn == false then
		SilHUD2MasterFrame:SetAlpha(SilHUD2Settings.alphas.globalAlpha);
	elseif UnitAffectingCombat("player") == 1 then
		SilHUD2MasterFrame:SetAlpha(SilHUD2Settings.alphas.highAlpha);
	elseif (UnitHealth("player") ~= UnitHealthMax("player") or (UnitMana("player") ~= UnitManaMax("player") and englishClass ~= "WARRIOR") or (UnitName("target") and UnitName("target") ~= "Unknown")) or UnitDebuff("player", 1) ~= nil or (UnitMana("player") > 0 and englishClass == "WARRIOR")then
		SilHUD2MasterFrame:SetAlpha(SilHUD2Settings.alphas.midAlpha);
	else
		SilHUD2MasterFrame:SetAlpha(SilHUD2Settings.alphas.lowAlpha);
	end
end

function SilHUD2:SparkInit()
	TICKDATA.lastTime = GetTime();
	TICKDATA.oldEnergy = UnitMana("player");
	local frame = getglobal("PlayerEnergySpark");
	frame:SetScript("OnUpdate", 	function()
												if UnitPowerType("player") == 3 then
													SH2PLENERGYSPARK:Show();
													TICKDATA.curTime = GetTime();
													local timeDiff = TICKDATA.curTime - TICKDATA.lastTime;
													TICKDATA.newEnergy = UnitMana("player");
													if timeDiff > TICKDATA.duration or TICKDATA.newEnergy > TICKDATA.oldEnergy then
														TICKDATA.lastTime = TICKDATA.curTime;
														TICKDATA.oldEnergy = TICKDATA.newEnergy;
													end
													SH2PLENERGYSPARK:ClearAllPoints();
													SH2PLENERGYSPARK:SetPoint("BOTTOM", SH2PLPOWERSCALEFRAME, "BOTTOM", 0, (((TICKDATA.curTime - TICKDATA.lastTime)/TICKDATA.duration) * (SH2PLPOWERSCALEFRAME:GetHeight() - 4)))
												else
													SH2PLENERGYSPARK:Hide();
													SH2PLENERGYSPARK:SetScript("OnUpdate", nil);
												end
											end);
end

function SilHUD2:TargetTargetCheck()
	if UnitName("targettarget") and UnitName("targettarget") ~= "Unknown" then
		if UnitName("targettarget") ~= SH2TARTARNAME then
			SH2TARTARNAMETEXT:SetText(UnitName("targettarget"));
			SH2TARTARNAME = UnitName("targetarget");
		end
	else
		SH2TARTARNAMETEXT:SetText("None");
		SH2TARTARNAME = "";
	end
end

function SilHUD2:Indicators()
	if UnitIsAFK("player") and not SH2AFKFRAME:IsVisible() then
		SH2AFKFRAME:Show();
	elseif not UnitIsAFK("player") and SH2AFKFRAME:IsVisible() then
		SH2AFKFRAME:Hide();
	end
	if UnitIsDND("player") and not SH2DNDFRAME:IsVisible() then
		SH2DNDFRAME:Show();
	elseif not UnitIsDND("player") and SH2DNDFRAME:IsVisible() then
		SH2DNDFRAME:Hide();
	end
	if UnitIsPVP("player") then
		if not SH2PVPFRAME:IsVisible() then
			SH2PVPFRAME:Show();
		end
--[[		if GetPVPDesired() then
			SH2PVPCANCELFRAME:Hide();
		else
			SH2PVPCANCELFRAME:Show();
		end		]]--
	elseif not UnitIsPVP("player") and SH2PVPFRAME:IsVisible() then
		SH2PVPFRAME:Hide();
		SH2PVPCANCELFRAME:Hide();
	end
end

